/*
 * Copyright notice from original mutt:
 * Copyright (C) 1996-2002 Michael R. Elkins <me@mutt.org>, and others
 *
 * This file is part of mutt-ng, see http://www.muttng.org/.
 * It's licensed under the GNU General Public License,
 * please see the file GPL in the top level source directory.
 */

#include <lib-lib/lib-lib.h>
#include <lib-lua/lib-lua.h>
#include <lib-ui/lib-ui.h>
#include <lib-mx/mx.h>
#include <lib-mx/compress.h>

#include "alias.h"
#include "crypt.h"
#include "pattern.h"

#if 0
typedef struct hook_t {
  int type;                     /* hook type */
  rx_t rx;                      /* regular expression */
  char *command;                /* filename, command or pattern to execute */
  pattern_t *pattern;           /* used for fcc,save,send-hook */
  struct hook_t *next;
} hook_t;

DO_INIT(hook_t, hook);
static inline void hook_wipe(hook_t *hk) {
    p_delete(&hk->command);
    pattern_list_wipe(&hk->pattern);
}
DO_NEW(hook_t, hook);
DO_DELETE(hook_t, hook);
DO_SLIST(hook_t, hook, hook_delete);

static hook_t *Hooks = NULL;
static unsigned long current_hook_type = 0;
#endif

void mutt_message_hook (CONTEXT * ctx, HEADER * hdr, int type)
{
#if 0
  BUFFER err, token;
  hook_t *hook;
  char buf[STRING];

  current_hook_type = type;

  err.data = buf;
  err.dsize = sizeof (buf);
  p_clear(&token, 1);
  for (hook = Hooks; hook; hook = hook->next) {
    if (!hook->command)
      continue;

    if (hook->type & type)
      if ((mutt_pattern_exec (hook->pattern, 0, ctx, hdr) > 0) ^ hook->rx.neg)
        if (mutt_parse_rc_line (hook->command, &token, &err) != 0) {
          mutt_error ("%s", err.data);
          mutt_sleep (1);
        }
  }
  p_delete(&token.data);
  current_hook_type = 0;
#endif
}

/* Deletes all hooks of type ``type'', or all defined hooks if ``type'' is 0 */
void mutt_folder_hook (char *path)
{
    lua_State *L = luaM_getruntime();
    lua_getglobal(L, "mod_core");             /* push mod_core        1 */
    lua_getfield(L, -1, "folder_hook");       /* push folder_hook()   2 */
    if (lua_isfunction(L, -1)) {
        lua_pushstring(L, LastFolder);
        lua_pushstring(L, CurrentFolder);
        if (lua_pcall(L, 2, 0, 0)) {
            lua_pop(L, 3);
            return;
        }
    }
    lua_pop(L, 2);
}

void mutt_default_save (char *path, ssize_t pathlen, HEADER * hdr)
{
  char tmp[_POSIX_PATH_MAX];
  address_t *adr;
  ENVELOPE *env = hdr->env;
  int fromMe = mutt_addr_is_user (env->from);

  if (!fromMe && env->reply_to && env->reply_to->mailbox)
    adr = env->reply_to;
  else if (!fromMe && env->from && env->from->mailbox)
    adr = env->from;
  else if (env->to && env->to->mailbox)
    adr = env->to;
  else if (env->cc && env->cc->mailbox)
    adr = env->cc;
  else
    adr = NULL;
  if (adr) {
    mutt_safe_path (tmp, sizeof (tmp), adr);
    snprintf (path, pathlen, "=%s", tmp);
  } else {
    *path = 0;
  }
}
